/*
 * Copyright 2016 Jan Dorazil <deu439@gmail.com>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

#include "changedetection.hpp"
#include "pipe.hpp"

#include <list>

void ChangeDetection::setData(const DataUnit& data)
/*
 * Creates and stores deep copy of the passed dataunit
 */
{
  mData = data.clone();
}

void ChangeDetection::addPipe(Pipe* pipe)
/*
 * Pipes are iterated in the order they were added in.
 * 
 * ChangeDetection instance doesnt own the pipes,
 * memory allocated for them must be managed from outside.
 */
{
  mPipes.push_back(pipe);
}

DataUnit ChangeDetection::detect()
{
  std::list<Pipe *>::iterator it;
  for( it = mPipes.begin(); it != mPipes.end(); ++it ){
    (*it)->process(mData);
  }
 
  return mData;
}
